package xyz.brassgoggledcoders.boilerplate.lib.common.utils;

import java.util.List;
import java.util.UUID;

import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.enchantment.EnchantmentHelper;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.item.crafting.FurnaceRecipes;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.nbt.NBTTagList;
import net.minecraft.util.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;

/**
 * @author warlordjones & decebaldecebal
 *
 */
public class ItemStackUtils
{
	public static Material getBlockMaterial(final IBlockAccess world, final BlockPos blockPos)
	{
		if (world.func_180495_p(blockPos) != null)
		{
			return world.func_180495_p(blockPos).func_177230_c().func_149688_o();
		}

		return Material.field_151579_a;
	}

	public static List<ItemStack> getDroppedItemStacks(World world, EntityPlayer player, IBlockState block, BlockPos blockPos)
	{
		return block.func_177230_c().getDrops(world, blockPos, block, EnchantmentHelper.func_77517_e(player));
	}

	public static boolean isSmeltable(ItemStack is)
	{
		return is != null && FurnaceRecipes.func_77602_a().func_151395_a(is) != null;
	}

	public static void spawnStackInWorld(World world, BlockPos blockPos, ItemStack stack)
	{
		world.func_175698_g(blockPos);
		world.func_72838_d(new EntityItem(world, blockPos.func_177958_n() + 0.5F, blockPos.func_177956_o() + 0.5F, blockPos.func_177952_p() + 0.5F, stack.func_77946_l()));
	}

	public static void addModifier(ItemStack itemStack, String attribute, double amount, int mode)
	{
		NBTTagList list = new NBTTagList();
		NBTTagCompound attributes = new NBTTagCompound();
		attributes.func_74778_a("Name", "Attribute");
		attributes.func_74778_a("AttributeName", attribute);
		attributes.func_74780_a("Amount", amount);
		attributes.func_74772_a("UUIDMost", UUID.randomUUID().getMostSignificantBits());
		attributes.func_74772_a("UUIDLeast", UUID.randomUUID().getLeastSignificantBits());
		attributes.func_74768_a("Operation", mode);

		list.func_74742_a(attributes);

		NBTTagCompound attributeModifierTag = itemStack.func_77978_p();
		attributeModifierTag.func_74782_a("AttributeModifiers", list);

		itemStack.func_77982_d(attributeModifierTag);
	}

	public static int getStackPosition(InventoryPlayer inventory, Item item)
	{
		for (int i = 0; i < inventory.func_70302_i_(); i++)
		{
			if ((inventory.func_70301_a(i) != null) && (item == inventory.func_70301_a(i).func_77973_b()))
			{
				return i;
			}
		}

		return -1;
	}

	public static ItemStack copyStackWithAmount(ItemStack stack, int amount)
	{
		if (stack == null)
			return null;
		ItemStack s2 = stack.func_77946_l();
		s2.field_77994_a = amount;
		return s2;
	}

	public static boolean isItemNonNull(ItemStack itemStack)
	{
		return itemStack != null && itemStack.func_77973_b() != null;
	}

	public static boolean isItemInstanceOf(ItemStack itemStack, Class itemClass)
	{
		return isItemNonNull(itemStack) && itemClass != null && itemClass.isInstance(itemStack.func_77973_b());
	}

}
